# Matrix Dart SDK

   [![](https://img.shields.io/pub/v/matrix_sdk.svg)](https://pub.dartlang.org/packages/matrix_sdk)
   [![](https://img.shields.io/matrix/pattle:matrix.org.svg)](https://matrix.to/#/#pattle:matrix.org)

   A Dart implementation of the federated communications protocol, Matrix.
   
## Usage
   
   ```dart
   var store = SqfliteStore();
   var homeserver = Homeserver(Uri.parse("https://matrix.org"));
   
   var user = await homeserver.login(Username("pit"), "pattle", store: store);
   
   await for (bool success in user.sync()) {
     await for (var room in user.rooms.all()) {
       // Do something    
     }
   }
   ```
   This example uses the [`SqfliteStore`](https://git.pattle.im/pattle/library/matrix-dart-sdk-sqflite)
   , which is a seperate dependency and only works on Flutter.
   
   Note that using a store is optional.